bash-common-api
===============

Common tools for bash scripts


## bash-common-api.sh

Functions:

* `is_variable_define_and_not_empty_safe` : Parameter variable name, return 0 if variable is defined and not empty.
* `exit_if_variable_not_define_or_empty` : Parameter variable name, print an error message and exit 1 if variable is empty or not defined.
* `is_variable_define_safe` : Parameter variable name, return 0 if variable is define (regardless empty or not).
* `get_variable_safe` : Parameter variable name, return 0 if variable is 0 and print value on stdout (regardless empty or not).
* `exit_if_variable_not_define` : Parameter variable name, print an error message and exit 1 if variable is not define (regardless empty or not).
* `exit_if_directory_not_exists` : Parameter a directory, print an error message and exit 1 if directory does not exists.
* `exit_if_file_not_exists` : Parameter a file, print an error message and exit 1 if file does not exists.
* `P` : get required next parameter, typical usage is `varname="$( P "$@" )" && shift`
* `convert_url_to_safe_filename` : Parameter an url, print to stdout a safe file name base on this URL.

## message-api.sh

Functions:

* `echofatal` : `echofatal ...` - Print formatted message to stderr using light red color.
* `echoerror` : `echoerror ...` - Print formatted message to stderr using red color.
* `echowarn` : `echowarn  ...` - Print formatted message to stderr using cyan color.
* `echoinfo` : `echoinfo  ...` - Print formatted message to stdout using yellow color.
* `echookay` : `echookay  ...` - Print formatted message to stdout using light green color.

When MESSAGE_API_HIDE_DATE is set to `true` date is not added in messages.


## lock-api.sh

Require `LOCKFILE` to be define before sourcing, typical definition is:

```bash
declare -r LOCKFILE='/var/lock/project-name'
```

TODOC: need more documentation


## json-api.sh

Functions:

* `load_vars_from_json` : `load_vars_from_json JSON_FILE JSON_PATH`
* `get_expanded_value_from_json` : `get_expanded_value_from_json JSON_STR KEY`
* `is_null_or_empty` : `is_null_or_empty VALUE`

