#!/bin/bash
#
# gitlab-tools:bin/glt-api/branch.sh
#
if [ "$( type -t call_gitlab )" != 'function' ] ; then
  # shellcheck disable=SC1090
  source "$( dirname "${BASH_SOURCE[0]}" )/glt-api.sh" || exit 1
fi

# Return one JSON with all branches of giving project_id
function gitlab_get_project_branches_by_projectid {
  local -r  gitlab="$1"
  local -ri projectid="$2"

  call_gitlab "${gitlab}" project-branch list --project-id "${projectid}" --all
}

function gitlab_get_project_branch_by_projectid_and_name {
  local -r  gitlab="$1"
  local -ri projectid="$2"
  local -r  branchname="$3"

  gitlab_get_project_branches_by_projectid "${gitlab}" "${projectid}" |
    jq "[ .[] | select( .name == \"${branchname}\" ) ]"
}
