#!/bin/bash
#
# gitlab-tools:bin/glt-api/glt-group-api.sh
#
if [ "$( type -t call_gitlab )" != 'function' ] ; then
  # shellcheck disable=SC1090
  source "$( dirname "${BASH_SOURCE[0]}" )/glt-api.sh" || exit 1
fi

# Return one JSON with all groups
function gitlab_get_all_groups {
  local -r gitlab="$1"

  call_gitlab "${gitlab}" group list --all
}

function gitlab_get_group_by_groupid {
  local -r  gitlab="$1"
  local -ri groupid="$2"

  gitlab_get_all_groups "${gitlab}" |
    jq "[ .[] | select( contains( .id==${groupid} ) ]"
}

function gitlab_get_group_by_groupname {
  local -r gitlab="$1"
  local -r groupname="$2"

  gitlab_get_all_groups "${gitlab}" |
    jq "[ .[] | select( .name==\"${groupname}\" ) ]"
}

function gitlab_get_group_by_id {
  local -r  gitlab="$1"
  local -ri groupid="$2"

  gitlab_get_all_groups "${gitlab}" |
    jq "[ .[] | select( .id==${groupid} ) ]"
}
