#!/bin/bash
#
# gitlab-tools:bin/glt-api/glt-project-api.sh
#
if [ "$( type -t call_gitlab )" != 'function' ] ; then
  # shellcheck disable=SC1090
  source "$( dirname "${BASH_SOURCE[0]}" )/glt-api.sh" || exit 1
fi

# Return one JSON with all projects
function gitlab_get_all_projects {
  local -r gitlab="$1"

  call_gitlab "${gitlab}" project list --all
}

function gitlab_get_projects_by_groupid {
  local -r  gitlab="$1"
  local -ri groupid="$2"

  gitlab_get_all_projects "${gitlab}" |
    jq "[ .[] | select( .namespace.id==${groupid} ) ]"
}

function gitlab_get_project_by_projectid {
  local -r  gitlab="$1"
  local -ri projectid="$2"

  gitlab_get_all_projects "${gitlab}" |
    jq "[ .[] | select( .id==${projectid} ) ]"
}

function gitlab_get_project_by_projectname {
  local -r gitlab="$1"
  local -r projectname="$2"

  gitlab_get_all_projects "${gitlab}" |
    jq "[ .[] | select( .name==\"${projectname}\" ) ]"
}

function gitlab_get_all_projects_configuration_not_used {
  local -r gitlab="$1"

  gitlab_get_all_projects "${gitlab}" |
    jq -c '.[] | select(.archived | contains("false"))'
}
