#!/bin/bash
#
# gitlab-tools:bin/glt-api/glt-user-api.sh
#
if [ "$( type -t call_gitlab )" != 'function' ] ; then
  # shellcheck disable=SC1090
  source "$( dirname "${BASH_SOURCE[0]}" )/glt-api.sh" || exit 1
fi

# Return one JSON with all users
function gitlab_get_all_users {
  local -r gitlab="$1"

  call_gitlab "${gitlab}" user list --all
}

function gitlab_get_user_by_userid {
  local -r  gitlab="$1"
  local -ri userid="$2"

  gitlab_get_all_users "${gitlab}" |
    jq "[ .[] | select( .id=${userid} ) ]"
}

function gitlab_get_user_by_user_name {
  local -r gitlab="$1"
  local -r name="$2"

  gitlab_get_all_users "${gitlab}" |
    jq "[ .[] | select( .name==\"${name}\" ) ]"
}

function gitlab_get_user_by_user_username {
  local -r gitlab="$1"
  local -r username="$2"

  gitlab_get_all_users "${gitlab}" |
    jq "[ .[] | select( .username==\"${username}\" ) ]"
}

