#!/bin/bash -e
# shellcheck disable=SC2034
#
# gitlab-tools:bin/install-config.sh
#

#
# Accoring to: http://www.pathname.com/fhs/pub/fhs-2.3.html
#
# Put everything into: /usr/local/share/kdeconnect_tools
# Ensure *.sh are executables and readonly
# Add links into: /usr/bin
#
declare -r INSTALL_DATA_DIR='/usr/local/share/gitlab-tools'
declare -r INSTALL_BIN_DIR='/usr/bin'

declare -r REMOVE_OLD="${INSTALL_DATA_DIR}/gitlab-tools-remove"
declare -r REMOVE_EXE="${INSTALL_DATA_DIR}/gitlab-tools-remove.sh"

declare -r INSTALL_LINKS='
gl-delete
gl-get
gl-post
gl-put
glt-branch
glt-group
glt-project
glt-user
glx-audit
glx-clone
glx-find-wrong-remote-urls
glx-projects-archived
glx-projects-configuration
glx-projects-issues_enabled-without-issues
glx-projects-protected-master-branch
glx-projects-shared-runners
glx-projects-wiki
'

declare -r INSTALL_EXE='
bin/gl-delete.sh
bin/gl-get.sh
bin/gl-post.sh
bin/gl-put.sh
bin/glt-branch.sh
bin/glt-group.sh
bin/glt-project.sh
bin/glt-user.sh
bin/glx-audit.sh
bin/glx-clone.sh
bin/glx-find-wrong-remote-urls.sh
bin/glx-projects-archived.sh
bin/glx-projects-configuration.sh
bin/glx-projects-issues_enabled-without-issues.sh
bin/glx-projects-protected-master-branch.sh
bin/glx-projects-shared-runners.sh
bin/glx-projects-wiki.sh
gitlab-tools-install.sh
gitlab-tools-remove.sh
'

declare -ra INSTALL_PACKAGES=( curl git jq )
