#!/bin/bash
#
# gitlab-tools:bin/utils/cache-api.sh
#

#declare -gr CACHE_TIMEOUT_DEFAULT='-30 seconds'
declare -gr CACHE_TIMEOUT_DEFAULT='-90 seconds'

function __get_cache_timeout__ {
  if is_variable_define_and_not_empty_safe 'CACHE_TIMEOUT' ; then
    echo "${CACHE_TIMEOUT}"
  else
    echo "${CACHE_TIMEOUT_DEFAULT}"
  fi
}

function get_cachefile_if_valid {
  local -r cachepath="/tmp/._cache_glt"
  # shellcheck disable=SC2001
  local -r cachename="_${USER}_$( sed -e 's/[^A-Za-z0-9._-]/_/g' <<<"$*" )"
  local -r cachefile="${cachepath}/${cachename}"

  if [ ! -d "${cachepath}" ] ; then
    mkdir -vp "${cachepath}" >&2 || exit 1
  fi

  local found=
  found="$( find "${cachepath}" -name "${cachename}" -newermt "$( __get_cache_timeout__ )" -not -empty )"

  if [ "${found}" == "${cachefile}" ] ; then
    echo "${found}"
  fi
}

function get_cachefile {
  local -r cachepath="/tmp/._cache_glt"
  # shellcheck disable=SC2001
  local -r cachename="_${USER}_$( sed -e 's/[^A-Za-z0-9._-]/_/g' <<<"$*" )"
  local -r cachefile="${cachepath}/${cachename}"

  echo "${cachefile}"
}
